/* nylon - (socks{4,5}) proxy
 * http://mesh.eecs.umich.edu/projects/nylon
 * marius aamodt eriksen (marius@umich.edu)
 * utility functions */

/* XXX remove unneeded */


#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/signal.h>
#include <sys/ioctl.h>
#if defined(__sun__)
#include <sys/sockio.h>
#endif /* __sun__ */

#include <net/if.h>
#include <netinet/in.h>

#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <errno.h>
#if __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif /* __STDC__ */

#include "mnet.h"
#include "cfg.h"
#include "util.h"


#define IFMAX IFNAMSIZ
#define DEFAULT_ALLOC 8

extern int verbose;

void
#if __STDC__
printv(int level, const char *fmt, ...)
#else
printv(fmt, va_alis)
char *fmt;
va_dcl
#endif /* __STDC__ */
{
	va_list ap;
#if __STDC__  
	va_start(ap, fmt);
#else
	va_start(ap);
#endif /* __STDC__ */	
	if (fmt && (level <= verbose)) {
		fprintf(stderr, "nylon: ");
		vfprintf(stderr, fmt, ap);
	}
	va_end(ap);
}

struct in_addr
get_ip_from_if(char *inf)
{
	struct ifreq ifr;
	struct sockaddr_in *sin;
	int bogusfd;
	char ifip[14];
	
	strlcpy(ifr.ifr_name, inf, IFMAX);
	bogusfd = socket(AF_INET, SOCK_STREAM, 0);
	ioctl(bogusfd, SIOCGIFADDR, &ifr);
	sin = (struct sockaddr_in *)&ifr.ifr_addr;
	/* display... */
	if (verbose) {
		inet_ntop(AF_INET, &sin->sin_addr, ifip, sizeof(ifip));
		printv(1, "binding to address %s\n", ifip);
	}
	return sin->sin_addr;
}

char**
expanda(const char *in)
{
	char **ret = NULL, *a;
	char tmp;
	unsigned i, j, k, ac;

	ac = i = k = 0;
	a = (char*)malloc(strlen(in)+1);
	strlcpy(a, in, strlen(in)+1);

	while (i < strlen(a)) {
		if ((k%DEFAULT_ALLOC) == 0) 
			ret = (char**)realloc(ret, sizeof(char*)*DEFAULT_ALLOC*(++ac));
		for (; a[i] && isspace(a[i]); i++);
		if (i >= strlen(a)) goto fin;
		for (j=i; a[j] && !isspace(a[j]); j++);
		tmp = a[j];
		a[j] = '\0';
		ret[k] = (char*)malloc(strlen(a+i)+1);
		strlcpy(ret[k], a+i, strlen(a+i)+1);
		a[j] = tmp;
		i = j;
		++k;
	}
	/* XXX */
 fin:
	if ((k%DEFAULT_ALLOC) == 0) 
		ret = (char**)realloc(ret, sizeof(char*)*DEFAULT_ALLOC*ac+1);
	ret[k] = NULL;
	return ret;
}



struct ip_chain*
make_ipchain(char **ip)
{
	struct ip_chain *node  = (struct ip_chain*)malloc(sizeof(struct ip_chain));
	struct ip_chain *nnode, *head;
	unsigned i;

	head  = NULL;
	nnode = NULL;

	while (*ip) {
		node = (struct ip_chain*)malloc(sizeof(struct ip_chain));
		node->next = NULL;
		if (!head) head = node;
		if (nnode) nnode->next = node;
		for (i=0; (*ip)[i] && ((*ip)[i] != '/'); i++);
		node->mask = 0xFFFFFFFF;
		if (i != strlen(*ip)) 
			node->mask <<= 32-atoi(*ip+i+1);
		(*ip)[i] = '\0';
		node->ip = inet_addr(*ip);
		nnode = node;
		*ip++;
	}
	
	if (verbose) {
		printf("ip chain:\n");
		for (node = head; node; node = node->next) {
			struct in_addr in;
			in.s_addr = node->ip;
			printf("%s\n", inet_ntoa(in));
			printf("%lx\n", node->mask);
		}
	}
	return head;
}

/* copyright (c) 2001  
 * marius aamodt eriksen
 * all rights reserved
 * 
 * permission is granted to use, copy, create derivative works and
 * redistribute this software and such derivative works for any purpose,
 * so long as the name of the author is not used in any advertising or 
 * publicity pertaining to the use or distribution of this software 
 * without specific, written prior authorization.  if the above copyright 
 * notice or any other identification of the author is included in any 
 * copy of any portion of this software, then the disclaimer below must 
 * also be included.
 * 
 * this software is provided as is, without representation from the
 * the author as to its fitness for any purpose, and withoutwarranty by 
 * the author of any kind, either express or implied, including without 
 * limitation the implied warranties of merchantability and fitness for 
 * a particular purpose.  the author shall not be liable for any damages,
 * including special, indirect, incidental, or consequential damages,
 * with respect to any claim arising out or in connection with the use
 * of the software, even if it has been or is hereafter advised of the
 * possibility of such damages. */
